# encoding=shiftjis
#
# pyDaTTS.py
#
# copyright(c) takayan
# http://

import sys
import re
from ctypes import *

# ff[^

# ꉹ\
phoneDurVowel = {
# ꉹ
	'a'   :  500,
	'i'   :  500,
	'u'   :  500,
	'e'   :  500,
	'o'   :  500,
# ꉹ
	'a:'  : 1000,
	'i:'  : 1000,
	'u:'  : 1000,
	'e:'  : 1000,
	'o:'  : 1000,
# ꉹ
	'i_0' :  500,
	'u_0' :  500,
# L
    'Q'   :  500,
# L
	'X'   :  500,
# |[Y(I~)
	'_'   :  500,
	','   :  200,
}


# q\
phoneDurConsonant= {
	'k'  : 130,
	's'  : 100,
	't'  :  55,
	'm'  :  55,
	'n'  :  80,
	'n1' :  55,
	'h'  :  55,
	'f'  :  55,
	'C'  :  55,
	'j'  :  55,
	'r'  :  55,
	'w'  :  55,
	'S'  : 250,
	'tS' : 300,
	'ts' : 100,
	'g'  :  55,
	'dz' :  55,
	'z'  : 200,
	'Z'  : 200,
	'dZ' : 200,
	'd'  :  55,
	'b'  :  55,
	'p'  :  55,
	'f'  :  55,
	'ts' :  55,
}

# Ή\i㑱̉fF{̝Lj
phoneNMap = {
	'a' : 'N:',
	'i' : 'N:',
	'u' : 'N:',
	'e' : 'N:',
	'o' : 'N:',
	'a:': 'N:',
	'i:': 'N:',
	'u:': 'N:',
	'e:': 'N:',
	'o:': 'N:',
	's' : 'N:',
	'h' : 'N:',
	'f' : 'N:',
	'S' : 'N:',
	'C' : 'N:',
	'w' : 'N:',
	'g' : 'G:',
	'k' : 'G:',
	't' : 'n:',
	'r' : 'n:',
	'dZ': 'n:',
	'dz': 'n:',
	'j' : 'N:',
	'ts': 'n:',
	'tS': 'n:',
	'd' : 'n:',
	'b' : 'm:',
	'p' : 'm:',
	'm' : 'm:',
	'n' : 'n:',
	'n1': 'n1:',
	'_' : 'N:',
	'Q' : 'N:',
	'z' : 'N:',
	'Z' : 'N:',
}

# /̂ƂɗƂɒu鉹̕\
phoneHeadRemap = {
	'Z' : 'dZ',
	'z' : 'dz',
}


# ϐ
mora = ""
prevCh  = ""
userDic = []


# XȂΕϊ
def yoon(boin):
	global prevCh

	if prevCh <>'' and ( boin == 'a' or boin == 'u' or  boin == 'o' ):
		if len(prevCh)>=3 and prevCh[-1] == 'i':
			if prevCh == 'C i':
				result = "C " + boin
			elif prevCh[-3] == 'Z':
				result = 'Z ' + boin
			elif prevCh[-3] == 'S':
				result = prevCh[0:-1] + boin
			elif prevCh[-3] == 'n':
				result = prevCh[0:-3] + ' n1 ' + boin
			else:
				result = prevCh[0:-1] + 'j ' + boin
		else:
			temp = prevCh
			result = 'j ' + boin
		return result
	return ''


# XȂΕϊ
def hanyoon(boin):
	global prevCh

	# J va,vi,ve,vo<-vu
	if  prevCh == 'v u' and ( boin == 'a' or  boin == 'i' or  boin == 'e' or  boin == 'o' ):
		result = 'v ' + boin

	# Ă ti<-te
	elif boin == 'i' and prevCh == 't e':
		result = 't i'

	# ł di<-de
	elif boin == 'i' and prevCh == 'd e':
		result = 'd i'

	#  Ze<-Zi
	elif boin == 'e' and prevCh == 'Z i':
		result = 'Z e'

	#  tSe<-tSi
	elif boin == 'e' and prevCh =='tS i':
		result = 'tS e'

	# XgȂALȊOȂΕꉹƌȂ
	else:
		if prevCh <> '':
			result = prevCh + ' ' + boin
		else:
			result = boin

#	print "ꉹ:",boin,"ϊO:",prevCh,"ϊ:",result
	return result

# Pʂŕϊ
# m肵Ƃ߂lB
# ŌɎĉŁAϐmoraɒڃANZX邱
def convert_bychar(s):
	vowel = ""
	consonant = ""
	global mora
	global prevCh

	# Ǒʂi[
	prevCh = mora
	mora = ""

	# mȉߏI[
	if ( s == u'B' ):
		if prevCh <> '':
			return prevCh + ' _'
		else:
			return '_'
	elif ( s == u'H' ) or ( s == u'?' ):
		if prevCh <> '':
			return prevCh + ' _'
		else:
			return '_'
	elif ( s == u'I' ) or ( s == u'!' ):
		if preCh <> '':
			return preCh + ' _'
		else:
			return '_'
	elif ( s == u'A' ) or ( s == u'C' ) or ( s == u',' ):
		if prevCh <> '':
			return prevCh + ' ,'
		else:
			return ','

	# L特ߏI
	elif ( s == u'[' ):
		if prevCh <> '':
			mora = ''
			return prevCh + ':'
		else:
			mora = ''
			return ''

	# iX̉\j
	elif ( s == u'@' ) or ( s == u'' ):
		temp = hanyoon('a')
		if temp <> '':
			mora = temp
			return ''
		else:
			mora = ''
			return ''

	elif ( s == u'B' ) or ( s == u'' ):
		temp = hanyoon('i')
		if temp <> '':
			mora = temp
			return ''
		else:
			mora = ''
			return ''

	elif ( s == u'D' ) or ( s == u'' ):
		temp = hanyoon('u')
		if temp <> '':
			mora = temp
			return ''
		else:
			mora = ''
			return ''

	elif ( s == u'F' ) or ( s == u'' ):
		temp = hanyoon('e')
		if temp <> '':
			mora = temp
			return ''
		else:
			mora = ''
			return ''

	elif ( s == u'H' ) or ( s == u'' ):
		temp = hanyoon('o')
		if temp <> '':
			mora = temp
			return ''
		else:
			mora = ''
			return ''

	elif ( s == u'' ) or ( s == u'' ):
		temp = yoon('a')
		if temp <> '':
			mora = temp
			return ''
		else:
			mora = ''
			return ''

	elif ( s == u'' ) or ( s == u'' ):
		temp = yoon('u')
		if temp <> '':
			mora = temp
			return ''
		else:
			mora = ''
			return ''

	elif ( s == u'' ) or ( s == u'' ):
		temp = yoon('o')
		if temp <> '':
			mora = temp
			return ''
		else:
			mora = ''
			return ''

	# L
	elif ( s == u'b' ) or ( s == u'' ):
		if prevCh <> '':
			mora = ''
			return prevCh + ' Q'
		else:
			mora = ''
			return 'Q'

	# BuJv̂Ƃ̂݁BȊO͕NA
	elif ( s == u'J' ):
		if prevCh == 'u':
			mora = "v u"
			return ''
		else:
			mora = ''
			return ''

	# BߏIB̕ŉς邪Aׂ͂ĂIĂB
	elif ( s == u'' ) or ( s == u'' ):
		mora = ''
		if prevCh <> '':
			return prevCh + ' X'
		else:
			return 'X'

	# Ƃ͒P\L
	elif ( s == u'A' ) or ( s == u'' ):
		mora =  'a'
	elif ( s == u'C' ) or ( s == u'' ):
		mora =  'i'
	elif ( s == u'E' ) or ( s == u'' ):
		mora =  'u'
	elif ( s == u'G' ) or ( s == u'' ):
		mora =  'e'
	elif ( s == u'I' ) or ( s == u'' ):
		mora =  'o'
	elif ( s == u'J' ) or ( s == u'' ):
		mora =  'k a'
	elif ( s == u'L' ) or ( s == u'' ):
		mora =  "k i"
	elif ( s == u'N' ) or ( s == u'' ):
		mora =  'k u'
	elif ( s == u'P' ) or ( s == u'' ):
		mora =  'k e'
	elif ( s == u'R' ) or ( s == u'' ):
		mora =  'k o'
	elif ( s == u'T' ) or ( s == u'' ):
		mora =  's a'
	elif ( s == u'V' ) or ( s == u'' ):
		mora =  "S i"
	elif ( s == u'X' ) or ( s == u'' ):
		mora =  's u'
	elif ( s == u'Z' ) or ( s == u'' ):
		mora =  's e'
	elif ( s == u'\' ) or ( s == u'' ):
		mora =  's o'
	elif ( s == u'^' ) or ( s == u'' ):
		mora =  't a'
	elif ( s == u'`' ) or ( s == u'' ):
		mora =  "tS i"
	elif ( s == u'c' ) or ( s == u'' ):
		mora =  'ts u'
	elif ( s == u'e' ) or ( s == u'' ):
		mora =  't e'
	elif ( s == u'g' ) or ( s == u'' ):
		mora =  't o'
	elif ( s == u'i' ) or ( s == u'' ):
		mora =  'n a'
	elif ( s == u'j' ) or ( s == u'' ):
		mora =  "n1 i"
	elif ( s == u'k' ) or ( s == u'' ):
		mora =  'n u'
	elif ( s == u'l' ) or ( s == u'' ):
		mora =  'n e'
	elif ( s == u'm' ) or ( s == u'' ):
		mora =  'n o'
	elif ( s == u'n' ) or ( s == u'' ):
		mora =  'h a'
	elif ( s == u'q' ) or ( s == u'' ):
		mora =  "C i"
	elif ( s == u't' ) or ( s == u'' ):
		mora =  "f u"
	elif ( s == u'w' ) or ( s == u'' ):
		mora =  'h e'
	elif ( s == u'z' ) or ( s == u'' ):
		mora =  'h o'
	elif ( s == u'}' ) or ( s == u'' ):
		mora =  'm a'
	elif ( s == u'~' ) or ( s == u'' ):
		mora =  "m i"
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'm u'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'm e'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'm o'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'j a'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'j u'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'j o'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'r a'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  "r i"
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'r u'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'r e'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'r o'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'w a'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'w a'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  "w i"
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'w e'
	elif ( s == u'' ) or ( s == u'' ):
		mora =  'w o'
	elif ( s == u'K' ) or ( s == u'' ):
		mora =  'g a'
	elif ( s == u'M' ) or ( s == u'' ):
		mora =  "g i"
	elif ( s == u'O' ) or ( s == u'' ):
		mora =  'g u'
	elif ( s == u'Q' ) or ( s == u'' ):
		mora =  'g e'
	elif ( s == u'S' ) or ( s == u'' ):
		mora =  'g o'
	elif ( s == u'U' ) or ( s == u'' ):
		mora =  'z a'
	elif ( s == u'W' ) or ( s == u'' ):
		mora = 'Z i'
	elif ( s == u'Y' ) or ( s == u'' ):
		mora =  'z u'
	elif ( s == u'[' ) or ( s == u'' ):
		mora =  'z e'
	elif ( s == u']' ) or ( s == u'' ):
		mora =  'z o'
	elif ( s == u'_' ) or ( s == u'' ):
		mora =  'd a'
	elif ( s == u'a' ) or ( s == u'' ):
		mora =  "d i"
	elif ( s == u'd' ) or ( s == u'' ):
		mora =  'Z u'
	elif ( s == u'f' ) or ( s == u'' ):
		mora =  "d e"
	elif ( s == u'h' ) or ( s == u'' ):
		mora =  'd o'
	elif ( s == u'o' ) or ( s == u'' ):
		mora =  'b a'
	elif ( s == u'r' ) or ( s == u'' ):
		mora =  "b i"
	elif ( s == u'u' ) or ( s == u'' ):
		mora =  'b u'
	elif ( s == u'x' ) or ( s == u'' ):
		mora =  'b e'
	elif ( s == u'{' ) or ( s == u'' ):
		mora =  'b o'
	elif ( s == u'p' ) or ( s == u'' ):
		mora =  'p a'
	elif ( s == u's' ) or ( s == u'' ):
		mora =  "p i"
	elif ( s == u'v' ) or ( s == u'' ):
		mora =  'p u'
	elif ( s == u'y' ) or ( s == u'' ):
		mora =  'p e'
	elif ( s == u'|' ) or ( s == u'' ):
		mora =  'p o'
	elif ( s == u'' ):
		mora =  'v u'

	# sȕ
	else:
		mora = ''
		if prevCh <> '':
			return prevCh
		else:
			return ''

	return prevCh


# azɂĊ̂ȂȂfLɕϊB
def convert_phonemes(s):
	global mora
	global userDic


	# ꂪȂΉȂ
	if s == '':
		return []



	# 񂩂特f̔z
	mora = ""
	phonemes = []
	for ch in s:
		ret = convert_bychar(ch)
		if ret <> '':
			phs = ret.split(" ")
			for ph in phs:
				phonemes.append(ph)
	if mora <> '':
		phs = mora.split(" ")
		for ph in phs:
			phonemes.append(ph)
		mora = ''
	if not phonemes:
		return []
	# Ƃ肠Afz񊮐 #

	# f̒vZBꉹ͐旧q̒Ē
	le = []
	length = 0
	for ph in phonemes:
		d = 50
		if ph <> "":
			if phoneDurConsonant.has_key(ph):
				d = phoneDurConsonant[ph]
				length = length + d
			if phoneDurVowel.has_key(ph):
				d = phoneDurVowel[ph] - length
				length = 0
		le.append(d)

	# yѝ̒̉fϊ@Z->dZ, z->dz
	last = '_'
	t = []
	for ph in phonemes:
		if ph <> '' and phoneHeadRemap.has_key(ph) and ( last == ',' or last == '_' or last == 'Q' or last == 'X' ):
			t.append( phoneHeadRemap[ph] )
		else:
			t.append( ph )
		last = ph
	if not t:
		return []
	phonemes = t

	# L{̉fɕϊ
	last = '_'
	t = []
	for ph in reversed(phonemes):
		if ph == 'X' and phoneNMap.has_key(last):
			ph =  phoneNMap[last]
		t.append(ph)
		last = ph
	phonemes = t[::-1]

# emF
#	for ph in phonemes:
#		print ph

	# ƂƂɏo͂B
	t = []
	scale = 0.4		# A{͊Owł悤ɂĂ
	t.append( '_\t300' )
	while len(phonemes)!=0:
		a = phonemes.pop(0)
		if a == 'X': # ϊłĂȂL폜
			le.pop(0)
			continue
		if len(le)!=0:
			b = le.pop(0)
		else:
			b = 100
		if a == ',':  # R}␳
			a = '_'
		if a == 'Q':  # L␳
			a = '_'
		t.append( a + '\t' + str(int(b*scale)) )
	t.append( '_\t300' )

	return t


# lp
numRead = {
	u"0":u"[",
	u"1":u"",
	u"2":u"",
	u"3":u"O",
	u"4":u"l",
	u"5":u"",
	u"6":u"Z",
	u"7":u"",
	u"8":u"",
	u"9":u"",
	u"O":u"[",
	u"P":u"",
	u"Q":u"",
	u"R":u"O",
	u"S":u"l",
	u"T":u"",
	u"U":u"Z",
	u"V":u"",
	u"W":u"",
	u"X":u"",
}


# p
numRead2 = {
	u"0":u"[",
	u"1":u"C`",
	u"2":u"j[",
	u"3":u"T",
	u"4":u"",
	u"5":u"S[",
	u"6":u"N",
	u"7":u"ii",
	u"8":u"n`",
	u"9":u"LE",
	u"O":u"[",
	u"P":u"C`",
	u"Q":u"j[",
	u"R":u"T",
	u"S":u"",
	u"T":u"S[",
	u"U":u"N",
	u"V":u"ii",
	u"W":u"n`",
	u"X":u"LE",
}

numClass1 = {
	u"1" : u"",
	u"2" : u"\",
	u"3" : u"S",
	u"4" : u"",
}

numClass2 = {
	u"0" : u"",
	u"1" : u"",
	u"2" : u"",
	u"3" : u"",
	u"4" : u"P[",
}

numYomiHosei = {
	u"OS":u"TrN",
	u"ZS":u"bsN",
	u"S":u"nbsN",
	u"O":u"T[",
	u"":u"nbZ",
}

# 񒆂̐l{ɕϊ
def convert_numstring(str):
	number = re.compile( u'([0-9O-X]+,*[0-9,O-X]*)(\.[0-9O-X]*)?' )
	zeros  = re.compile( u'^[0O]+$' )
	comma  = re.compile( ',' );

	# [vAlȂΓrŃ^[
	for n in range(100):

		# l
		val = number.search( str )
		if val == None:
			return str;
			
		# Ə
		i = val.group(1)
		r = val.group(2)

		# i[z񏉊
		s = []

		# [Ȃ鐔l͂ǂ[
		if zeros.search( i ):
			i = '0'

		## ̏
		# ؂́u,v΍폜
		i = comma.sub( '', i )
		olen  = len(i)

		# l蒷
		while len(i) > 4:

			par = []
			par.append( i[0] )
			i = i[1::]
			while len(i)%4 != 0:
				par.append( i[0] )
				i = i[1:]

			flag = 0
			while par<>[]:
				if par[0] != '0':
					flag = 1
					# u1vȊO͕KǂށAԉ̌ȂΉłǂ
					if par[0] != '1' or len(par) == 1:
						s.append( numRead[par[0]] )
					s.append( numClass1[`len(par)`] )
				par.pop(0)

			# 0ȊO̐
			if flag == 1:
				num = int(len(i)/4)
				s.append( numClass2[`num`] )

		# lZĈꌅłȂ
		while len(i) > 1:
			if i[0] != '0':
				# u1vȊO͕KǂށAԉ̌ȂΉłǂ
				if i[0] != '1' or len(i) == 1:
					s.append( numRead[i[0]] )
				s.append( numClass1[`len(i)`] )
			i = i[1:]

		## ̈ʂ̏
		# ̈ʂ[Ȃ
		if i[0] == '0':
			# ꌅȂ΁A
			if olen == 1:
				# ȂΕʂɓǂ
				if r == '':
					s.append( numRead[i[0]] )
					i = i[1::]
				 # ꍇ́uꂢvƓǂ
				else:
					s.append( u"C" )
		# ̈ʂ[ȊOȂΕʂɓǂ
		else:
			s.append( numRead[i[0]] )
			i = i[1::]

		## ̏
		# _ȉΓǂ
		if r <> None:
			s.append( u"e" )
			r = r[1::]		# _L̂Ă
			for n in r:
				s.append( numRead2[n] )

		# zA
		s = u''.join(s)

		# lǂݕ␳
		for i in numYomiHosei:
			s = re.sub( i, numYomiHosei[i], s )

		# u
		temp = ""
		if val.start(0) > 0:
			temp = str[0:val.start(0)]
		temp = temp + s
		if len(str)>val.end(0):
			temp = temp + str[val.end(0):]
		str = temp


# ̃\[gpr֐îɒׂ悤ɂj
def length_comp(a,b):
	a = a.split(',')
	if a == []:
		return -1
	b = b.split(',')
	if b == []:
		return 1
	return len(b[0]) - len(a[0])


# ȈՎǂݍ
def load_userdic():
	global userDic

	f = open('userdic.txt', 'r')
	userDic = []
	for line in f:
		userDic.append( unicode(line.strip(), 'Shift_JIS' ) )
	userDic.sort( length_comp )
	f.close()

# ȈՎgăAt@xbgȂǂJi\Lɒu
def convert_bydic(s):
	global userDic

	for line in userDic:
		word = line.split(',')
		if len( word ) == 2:
			s = re.compile( word[0] ).sub( word[1], s )
	return s

# eLXgfϊ
def nihongo2phonemes(infile,outfile):
	# mecab.dll̃[h
	libpath = 'C:/Program Files/MeCab/bin/libmecab.dll'
	lib = cdll.LoadLibrary(libpath)
	argc = c_int(4)
	argv = (c_char_p * 4)( "mecab", "-F%pS%f[8] ", "-U%M", "-E " )
	tagger = lib.mecab_new(argc, argv)

	# ȈՎǂݍ
	load_userdic()

	# ͂̊esɑ΂
	for s in infile:
		s = s.strip()
		if s == '':
			continue

		# jR[hɕϊ
		s = unicode(s,'Shift_JIS')

		# 񒆂̐l{ɕϊ
		s = convert_numstring(s)

		# ȈՎgăAt@xbgȂǂJi\Lɒu
		s = convert_bydic(s)

		# MeCabŊɕϊ
		s = s.encode('mbcs')
		s = lib.mecab_sparse_tostr(tagger,s)
		s = c_char_p(s).value

		# ĂуjR[hɕϊ
		s = unicode(s,'Shift_JIS')

		# fLɕϊ
		ps = convert_phonemes(s)
		if ps == []:
			continue

		# fXgo
		for ph in ps:
			outfile.write(ph+'\n')

	# dll
	lib.mecab_destroy(tagger)


# C
nihongo2phonemes(sys.stdin,sys.stdout)

